Index: tmp/org.txm.core/src/java/org/txm/importer/StaxIdentityParser.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/importer/StaxIdentityParser.java	(revision 0)
+++ tmp/org.txm.core/src/java/org/txm/importer/StaxIdentityParser.java	(revision 313)
@@ -0,0 +1,393 @@
+package org.txm.importer;
+
+import java.io.BufferedOutputStream;
+import java.io.File;
+import java.io.FileOutputStream;
+import java.io.IOException;
+import java.io.InputStream;
+import java.net.URL;
+
+import javax.xml.stream.XMLInputFactory;
+import javax.xml.stream.XMLOutputFactory;
+import javax.xml.stream.XMLStreamConstants;
+import javax.xml.stream.XMLStreamException;
+import javax.xml.stream.XMLStreamReader;
+import javax.xml.stream.XMLStreamWriter;
+
+public class StaxIdentityParser {
+	/** The input */
+	protected URL inputurl;
+	protected InputStream inputData;
+	protected XMLInputFactory factory;
+	protected XMLStreamReader parser;
+
+	/** The output. */
+	protected XMLOutputFactory outfactory = XMLOutputFactory.newInstance();
+	protected BufferedOutputStream output;
+	protected XMLStreamWriter writer;
+
+	public static String TXMNS = "http://textometrie.org/1.0";
+	public static String TXM = "txm";
+	public static String TEINS = "http://www.tei-c.org/ns/1.0";
+	public static String TEI = "tei";
+	protected static PersonalNamespaceContext Nscontext = new PersonalNamespaceContext();
+
+	//protected StringBuilder currentXPath = new StringBuilder("/")
+	protected String localname;
+	int processingXInclude = 0;
+
+	public StaxIdentityParser(File infile) throws IOException, XMLStreamException {
+		this(infile.toURI().toURL());
+	}
+
+	public StaxIdentityParser(URL inputurl) throws IOException, XMLStreamException {
+		this.inputurl = inputurl;
+		this.inputData = inputurl.openStream();
+		this.factory = XMLInputFactory.newInstance();
+		this.parser = factory.createXMLStreamReader(inputData);
+	}
+
+	protected void before() {
+
+	}
+
+	protected void after() throws XMLStreamException, IOException {
+		factory = null;
+		if (parser !=null) parser.close();
+		writer.flush();
+		if (writer != null) writer.close();
+		if (inputData != null) inputData.close();
+		writer = null;
+		parser = null;
+	}
+
+	protected void closeForError() throws XMLStreamException {
+		parser.close();
+	}
+
+	/**
+	 * Creates the output.
+	 *
+	 * @param outfile the outfile
+	 * @return true, if successful
+	 */
+	private boolean createOutput(File f) {
+		try {
+			if (writer != null) // process from a file
+				writer.close();
+			if (output != null) // process from a file
+				output.close();
+
+			output = new BufferedOutputStream(new FileOutputStream(f), 16*1024);
+
+			writer = outfactory.createXMLStreamWriter(output, "UTF-8");//create a new file
+			writer.setNamespaceContext(Nscontext);
+			return true;
+		} catch (Exception e) {
+			System.out.println("Error: create output of "+f+": "+e);
+			return false;
+		}
+	}
+
+	public boolean process(File outfile) throws XMLStreamException, IOException
+	{
+		if (!createOutput(outfile))
+			return false;
+
+		writer.writeStartDocument("UTF-8", "1.0");
+		writer.writeCharacters("\n");
+		boolean ret = process(writer);
+		if (writer != null) { // process from a file
+			writer.close();
+		}
+		if (output != null) { // process from a file
+			//	output.flush()
+			output.close();
+		}
+
+		if (parser != null) {
+			try {parser.close();} catch(Exception e){System.out.println("parser exep: "+e); return false;}
+		}
+		return ret;
+	}
+
+	public final static String SLASH = "/";
+	public boolean process(XMLStreamWriter awriter) throws XMLStreamException, IOException
+	{
+		this.writer = awriter;
+		//if (processingXInclude == 0) {
+		before(); // if you need to do something before reading the xml
+		//}
+		try {
+			for (int event = parser.next(); event != XMLStreamConstants.END_DOCUMENT; event = parser.next()) {
+				switch (event) {
+				case XMLStreamConstants.NAMESPACE:
+					processNamespace();
+					break;
+				case XMLStreamConstants.START_ELEMENT:
+					localname = parser.getLocalName();
+					//currentXPath.append(SLASH)
+					processStartElement();
+					break;		
+				case XMLStreamConstants.CHARACTERS:
+					processCharacters();
+					break;
+				case XMLStreamConstants.END_ELEMENT:
+					localname = parser.getLocalName();
+					processEndElement();
+					//currentXPath.substring(0, currentXPath.length() - localname.length() -1)
+					break;
+				case XMLStreamConstants.PROCESSING_INSTRUCTION:
+					processProcessingInstruction();
+					break;
+				case XMLStreamConstants.DTD:
+					processDTD();
+					break;
+				case XMLStreamConstants.CDATA:
+					processCDATA();
+					break;
+				case XMLStreamConstants.COMMENT:
+					processComment();
+					break;
+				case XMLStreamConstants.END_DOCUMENT:
+					processEndDocument();
+					break;
+				case XMLStreamConstants.ENTITY_REFERENCE:
+					processEntityReference();
+					break;
+				}
+			}
+		} catch(Exception e) {
+			System.out.println("Unexpected error while parsing file "+inputurl+" : "+e);
+			System.out.println("Location line: "+parser.getLocation().getLineNumber()+" character: "+parser.getLocation().getColumnNumber());
+			org.txm.utils.logger.Log.printStackTrace(e);
+			//e.printStackTrace();
+			if (writer != null) writer.close();
+			if (output != null) output.close();
+			parser.close();
+			return false;
+		}
+		//if (processingXInclude == 0) {
+		after(); // if you need to do something before closing the parser();
+		//}
+		return true;
+	}
+
+	/**
+	 * The start element has already been written
+	 * @param tagname
+	 * @throws XMLStreamException 
+	 * @throws IOException 
+	 */
+	public void goToEnd(String tagname) throws XMLStreamException, IOException {
+		//System.out.println("start gotoend $tagname"
+		int elements = 1;
+		try {
+			for (int event = parser.next(); event != XMLStreamConstants.END_DOCUMENT; event = parser.next()) {
+				//System.out.println("event "+event
+				switch (event) {
+				case XMLStreamConstants.NAMESPACE:
+					processNamespace();
+					break;
+				case XMLStreamConstants.START_ELEMENT:
+					elements++;
+					localname = parser.getLocalName();
+					//currentXPath.append(SLASH)
+					_processStartElement();
+					break;
+				case XMLStreamConstants.CHARACTERS:
+					processCharacters();
+					break;
+				case XMLStreamConstants.PROCESSING_INSTRUCTION:
+					processProcessingInstruction();
+					break;
+				case XMLStreamConstants.DTD:
+					processDTD();
+					break;
+				case XMLStreamConstants.CDATA:
+					processCDATA();
+					break;
+				case XMLStreamConstants.COMMENT:
+					processComment();
+					break;
+				case XMLStreamConstants.END_ELEMENT:
+					elements--;
+					localname = parser.getLocalName();
+					//currentXPath.substring(0, currentXPath.length() - localname.length() -1)
+					writer.writeEndElement();
+					if (elements == 0 && localname == tagname)
+						return;
+					break;
+				case XMLStreamConstants.END_DOCUMENT:
+					processEndDocument();
+					break;
+				case XMLStreamConstants.ENTITY_REFERENCE:
+					processEntityReference();
+					break;
+				}
+			}
+		} catch(Exception e) {
+			System.out.println("Error while parsing file "+inputurl);
+			System.out.println("Location "+parser.getLocation());
+			org.txm.utils.logger.Log.printStackTrace(e);
+			output.close();
+			parser.close();
+			return;
+		}
+	}
+
+	public String getLocation() {
+		if (parser != null)
+			return "Line: "+parser.getLocation().getLineNumber()+" Col: "+parser.getLocation().	getColumnNumber();
+		return null;
+	}
+
+	protected void processNamespace() throws XMLStreamException {
+		writer.writeNamespace(parser.getPrefix(), parser.getNamespaceURI());
+	}
+
+	public static final String INCLUDE = "include";
+	public static final String XI = "xi";
+
+	protected void processStartElement() throws XMLStreamException, IOException
+	{
+		String prefix = parser.getPrefix();
+		if (INCLUDE == localname && XI == prefix) {
+			processXInclude();
+		} else {
+			if (prefix != null && prefix.length() > 0)
+				writer.writeStartElement(Nscontext.getNamespaceURI(prefix), localname);
+			else
+				writer.writeStartElement(localname);
+
+			for (int i = 0 ; i < parser.getNamespaceCount() ; i++) {
+				writer.writeNamespace(parser.getNamespacePrefix(i), parser.getNamespaceURI(i));
+			}
+
+			writeAttributes();
+		}
+	}
+
+	private void _processStartElement() throws XMLStreamException, IOException
+	{
+		String prefix = parser.getPrefix();
+		if (INCLUDE == localname && XI == prefix) {
+			processXInclude();
+		} else {
+			if (prefix != null && prefix.length() > 0)
+				writer.writeStartElement(Nscontext.getNamespaceURI(prefix), localname);
+			else
+				writer.writeStartElement(localname);
+
+			for (int i = 0 ; i < parser.getNamespaceCount() ; i++) {
+				writer.writeNamespace(parser.getNamespacePrefix(i), parser.getNamespaceURI(i));
+			}
+
+			writeAttributes();
+		}
+	}
+
+	protected void writeAttributes() throws XMLStreamException {
+		for (int i = 0 ; i < parser.getAttributeCount() ; i++) {
+			writeAttribute(parser.getAttributePrefix(i), parser.getAttributeLocalName(i), parser.getAttributeValue(i));
+		}
+	}
+
+	protected void writeAttribute(String prefix, String name, String value) throws XMLStreamException {
+		if (prefix != null && prefix.length() > 0)
+			writer.writeAttribute(prefix+":"+name, value);
+		else
+			writer.writeAttribute(name, value);
+	}
+
+	protected void processCharacters() throws XMLStreamException
+	{
+		writer.writeCharacters(parser.getText());
+	}
+
+	protected void processProcessingInstruction() throws XMLStreamException
+	{
+		writer.writeProcessingInstruction(parser.getPITarget(), parser.getPIData());
+	}
+
+	protected void processDTD() throws XMLStreamException
+	{
+		writer.writeDTD(parser.getText());
+	}
+
+	protected void processCDATA() throws XMLStreamException
+	{
+		writer.writeCData(parser.getText())	;
+	}
+
+	protected void processComment() throws XMLStreamException
+	{
+		writer.writeComment(parser.getText());
+	}
+
+	protected void processEndElement() throws XMLStreamException
+	{
+		if (localname == INCLUDE && parser.getPrefix() == XI) {
+			// nothing !!
+		} else {
+			writer.writeEndElement();
+		}
+	}
+
+	protected void processEndDocument() throws XMLStreamException {
+		writer.writeEndDocument();
+	}
+
+	protected void processEntityReference() throws XMLStreamException {
+		writer.writeEntityRef(parser.getLocalName());
+	}
+	/**
+	 * Process the XInclude elements
+	 * @throws IOException 
+	 * @throws XMLStreamException 
+	 */
+	protected void processXInclude() throws XMLStreamException, IOException {
+		String url = parser.getAttributeValue(null, "href"); // relative only
+		File driver = new File(inputurl.getFile());
+		File ref = new File(driver.getParent(), url);
+		if (ref.exists()) {
+			URL includeurl = ref.toURI().toURL();
+			// save variables before killing them
+			System.out.println("process xi include: "+ref);
+			XMLStreamReader parserSave = this.parser; // back up current parser
+			InputStream xiIncludeInputData = includeurl.openStream();
+			XMLStreamReader xiIncludeParser = factory.createXMLStreamReader(xiIncludeInputData);
+			parser = xiIncludeParser;
+			processingXInclude++; // to avoid recalling before & after methods
+			this.process(writer);
+			processingXInclude--; // end of XInclude processing
+			this.parser = parserSave; // restore parser
+		} else {
+			System.out.println("Warning referenced file: $ref does not exists");
+		}
+	}
+
+	public static void main(String[] args)
+	{
+		try {
+			File input = new File("/home/mdecorde/xml/xiinclude/master.xml");
+			File output = new File("/home/mdecorde/xml/xiinclude/merged.xml");
+			if (!(input.exists() && input.canRead())) {
+				System.out.println("cannot found $input");
+				return;
+			}
+			StaxIdentityParser builder;
+
+			builder = new StaxIdentityParser(input.toURI().toURL());
+
+			if (builder.process(output)) {
+				System.out.println("success ? "+ValidateXml.test(output));
+			} else {
+				System.out.println("failure !");
+			}
+		} catch (Exception e) {
+			// TODO Auto-generated catch block
+			e.printStackTrace();
+		}
+	}
+}
\ No newline at end of file

Index: tmp/org.txm.core/src/java/org/txm/importer/cwb/ReadRegistryFile.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/importer/cwb/ReadRegistryFile.java	(revision 0)
+++ tmp/org.txm.core/src/java/org/txm/importer/cwb/ReadRegistryFile.java	(revision 313)
@@ -0,0 +1,71 @@
+package org.txm.importer.cwb;
+
+import java.io.File;
+import java.util.ArrayList;
+import java.util.HashMap;
+
+import org.txm.utils.io.IOUtils;
+
+public class ReadRegistryFile {
+	File registryFile;
+	ArrayList<String> pAttributes;
+	ArrayList<String> sAttributes;
+	HashMap<String, ArrayList<String>> sattrs;
+	
+	public ReadRegistryFile(File registryFile) {
+		this.registryFile = registryFile;
+		read();
+	}
+	
+	public void read() {
+		pAttributes = new ArrayList();
+		sAttributes = new ArrayList();
+		sattrs = new HashMap<String, ArrayList<String>>();
+		for (String line : IOUtils.getLines(registryFile, System.getProperty("file.encoding"))) {
+			line = line.trim(); // remove first tab
+
+			if (line.startsWith("ATTRIBUTE ")) {
+				line = line.substring(10);
+				pAttributes.add(line);
+			} else if (line.startsWith("STRUCTURE ")) {
+				line = line.substring(9);
+				line = line.replaceAll("\\#.*", "");
+				line = line.trim();
+				String[] split = line.split("_", 2);
+				//println split
+				if (split.length == 1) { // sattr decl
+					sattrs.put(split[0], new ArrayList<String>());
+				} else {
+					sattrs.get(split[0]).add(split[1]);
+				}
+			}
+		}
+		
+		for (String sattr : sattrs.keySet()) {
+			String tmp = ""+sattr+":0";
+			for (String attr : sattrs.get(sattr))
+				tmp += "+"+attr;
+			sAttributes.add(tmp);
+		}
+	}
+	
+	public ArrayList<String> getPAttributes() {
+		return pAttributes;
+	}
+	
+	public ArrayList<String> getSAttributes() {
+		return sAttributes;
+	}
+	
+	public HashMap<String, ArrayList<String>> getSAttributesMap() {
+		return sattrs;
+	}
+	
+	public static void main(String[] args) {
+		File registry = new File("/home/matt/xml/wtc/discours");
+		ReadRegistryFile reader = new ReadRegistryFile(registry);
+		System.out.println("pAttributes: "+reader.getPAttributes());
+		System.out.println("sAttributes Map: "+reader.getSAttributesMap());
+		System.out.println("sAttributes: "+reader.getSAttributes());
+	}
+}
Index: tmp/org.txm.core/src/java/org/txm/importer/cwb/CwbEncode.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/importer/cwb/CwbEncode.java	(revision 312)
+++ tmp/org.txm.core/src/java/org/txm/importer/cwb/CwbEncode.java	(revision 313)
@@ -37,6 +37,7 @@
 import org.eclipse.osgi.util.NLS;
 import org.txm.Toolbox;
 import org.txm.core.messages.TXMCoreMessages;
+import org.txm.core.preferences.TBXPreferences;
 import org.txm.searchengine.cqp.clientExceptions.ServerNotFoundException;
 import org.txm.stat.utils.ConsoleProgressBar;
 import org.txm.utils.OSDetector;
@@ -176,7 +177,7 @@
 		 */
 
 		// Warning !! for WINDOWS ONLY the "" value does not work with the ProcessBuilder we must set the value to "\"\""
-		String empty_value_code = Toolbox.getParam(Toolbox.CQP_EMPTY_VALUE_CODE);
+		String empty_value_code = Toolbox.getParam(TBXPreferences.CQP_EMPTY_VALUE_CODE);
 		if (OSDetector.isFamilyWindows()) {
 			if (empty_value_code == null) empty_value_code = "\"\"";
 			empty_value_code = empty_value_code.trim();
Index: tmp/org.txm.core/src/java/org/txm/importer/cwb/CwbProcess.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/importer/cwb/CwbProcess.java	(revision 312)
+++ tmp/org.txm.core/src/java/org/txm/importer/cwb/CwbProcess.java	(revision 313)
@@ -37,6 +37,7 @@
 
 import org.apache.commons.lang.StringUtils;
 import org.txm.core.messages.TXMCoreMessages;
+import org.txm.core.preferences.TBXPreferences;
 import org.txm.searchengine.cqp.clientExceptions.ServerNotFoundException;
 import org.txm.utils.logger.Log;
 
@@ -241,7 +242,7 @@
 	 */
 	public static String getCWBLocation()
 	{
-		String cwbLoc = org.txm.Toolbox.getParam(org.txm.Toolbox.CQI_SERVER_PATH_TO_CQPLIB)+File.separator;
+		String cwbLoc = org.txm.Toolbox.getParam(TBXPreferences.CQI_SERVER_PATH_TO_CQPLIB)+File.separator;
 
 		if (!new File(cwbLoc).exists()) {
 			System.out.println(TXMCoreMessages.CwbProcess_5+cwbLoc);
